diff --git a/Documentation/devicetree/bindings/gpu/host1x/nvidia,tegra210-nvdec.yaml b/Documentation/devicetree/bindings/gpu/host1x/nvidia,tegra210-nvdec.yaml
index 3cf862976448..27128a195b66 100644
--- a/Documentation/devicetree/bindings/gpu/host1x/nvidia,tegra210-nvdec.yaml
+++ b/Documentation/devicetree/bindings/gpu/host1x/nvidia,tegra210-nvdec.yaml
@@ -24,17 +24,11 @@ properties:
       - nvidia,tegra210-nvdec
       - nvidia,tegra186-nvdec
       - nvidia,tegra194-nvdec
+      - nvidia,tegra234-nvdec
 
   reg:
     maxItems: 1
 
-  clocks:
-    maxItems: 1
-
-  clock-names:
-    items:
-      - const: nvdec
-
   resets:
     maxItems: 1
 
@@ -50,18 +44,6 @@ properties:
 
   dma-coherent: true
 
-  interconnects:
-    items:
-      - description: DMA read memory client
-      - description: DMA read 2 memory client
-      - description: DMA write memory client
-
-  interconnect-names:
-    items:
-      - const: dma-mem
-      - const: read-1
-      - const: write
-
   nvidia,host1x-class:
     description: |
       Host1x class of the engine, used to specify the targeted engine
@@ -79,7 +61,103 @@ required:
   - reset-names
   - power-domains
 
-additionalProperties: false
+unevaluatedProperties: false
+
+allOf:
+  - if:
+      properties:
+        compatible:
+          contains:
+            enum:
+              - nvidia,tegra234-nvdec
+    then:
+      properties:
+        clocks:
+          items:
+            - description: NVDEC clock
+            - description: FUSE clock
+            - description: TSEC_PKA clock
+        clock-names:
+          items:
+            - const: nvdec
+            - const: fuse
+            - const: tsec_pka
+        interconnects:
+          items:
+            - description: DMA read memory client
+            - description: DMA write memory client
+        interconnect-names:
+          items:
+            - const: dma-mem
+            - const: write
+        nvidia,memory-controller:
+          $ref: /schemas/types.yaml#/definitions/phandle
+          description:
+            phandle to the memory controller for determining carveout information.
+        nvidia,bl-manifest-offset:
+          $ref: /schemas/types.yaml#/definitions/uint32
+          description:
+            Offset to bootloader manifest from beginning of firmware. Typically set as
+            part of a device tree overlay corresponding to flashed firmware.
+        nvidia,bl-code-offset:
+          $ref: /schemas/types.yaml#/definitions/uint32
+          description:
+            Offset to bootloader code section from beginning of firmware. Typically set as
+            part of a device tree overlay corresponding to flashed firmware.
+        nvidia,bl-data-offset:
+          $ref: /schemas/types.yaml#/definitions/uint32
+          description:
+            Offset to bootloader data section from beginning of firmware. Typically set as
+            part of a device tree overlay corresponding to flashed firmware.
+        nvidia,os-manifest-offset:
+          $ref: /schemas/types.yaml#/definitions/uint32
+          description:
+            Offset to operating system manifest from beginning of firmware. Typically set as
+            part of a device tree overlay corresponding to flashed firmware.
+        nvidia,os-code-offset:
+          $ref: /schemas/types.yaml#/definitions/uint32
+          description:
+            Offset to operating system code section from beginning of firmware. Typically set as
+            part of a device tree overlay corresponding to flashed firmware.
+        nvidia,os-data-offset:
+          $ref: /schemas/types.yaml#/definitions/uint32
+          description:
+            Offset to operating system data section from beginning of firmware. Typically set as
+            part of a device tree overlay corresponding to flashed firmware.
+      required:
+        - nvidia,memory-controller
+        - nvidia,bl-manifest-offset
+        - nvidia,bl-code-offset
+        - nvidia,bl-data-offset
+        - nvidia,os-manifest-offset
+        - nvidia,os-code-offset
+        - nvidia,os-data-offset
+  - if:
+      properties:
+        compatible:
+          contains:
+            enum:
+              - nvidia,tegra210-nvdec
+              - nvidia,tegra186-nvdec
+              - nvidia,tegra194-nvdec
+    then:
+      properties:
+        clocks:
+          items:
+            - description: NVDEC clock
+        clock-names:
+          items:
+            - const: nvdec
+        interconnects:
+          items:
+            - description: DMA read memory client
+            - description: DMA read 2 memory client
+            - description: DMA write memory client
+        interconnect-names:
+          items:
+            - const: dma-mem
+            - const: read-1
+            - const: write
 
 examples:
   - |